#!/usr/bin/env python3
 
from turtle import *
 
# A) výpočet předpisu
pravidla = {
    'F': 'F+f-FF+F+FF+Ff+FF-f+FF-F-FF-Ff-FFF',
    'f': 'ffffff',
}
 
řetězec = 'F+F+F+F'
 
for i in range(3):
    nová_generace = ''
    for znak in řetězec:
        nová_generace += pravidla.get(znak, znak)
    print(i, ':', nová_generace)
    řetězec = nová_generace
 
# B) vykreslení obrázku podle získaného předpisu
speed(0)
left(90)
 
zásobník_pozic = []
for znak in řetězec:
    match znak:
        case 'F':
            fd(10)
        case 'f':
            up()
            fd(10)
            down()
        case '+':
            left(90)
        case '-':
            right(90)
        case '[':
            # ulož aktuální polohu želvy
            zásobník_pozic.append( (position(), heading()) )
        case ']':
            # načti poslední uloženou polohu želvy..
            p, h = zásobník_pozic.pop()
            # ..a nastav podle ní aktuální stav želvy
            up()
            setposition(p)
            setheading(h)
            down()
        # všechny ostatní možné znaky nedělají nic
        case _:
            ...
 
hideturtle()
done()
